use std::{collections::HashSet, cmp::min};

fn main() {
    const INPUT: &str = include_str!("../input.txt");
    let input = INPUT.lines();

    let mut count_complete: u64 = 0;
    let mut count_partial: u64 = 0;
    for line in input {
        let (first, second) = line.split_once(',').unwrap();

        let first: (&str, &str) = first.split_once('-').unwrap();
        let first: (u64, u64) = (first.0.parse::<u64>().unwrap(), first.1.parse::<u64>().unwrap());

        let second: (&str, &str) = second.split_once('-').unwrap();
        let second: (u64, u64) = (second.0.parse::<u64>().unwrap(), second.1.parse::<u64>().unwrap());

        let first_set: HashSet<u64> = HashSet::from_iter(first.0..=first.1);
        let second_set: HashSet<u64> = HashSet::from_iter(second.0..=second.1);

        let smallest_len = min(first_set.len(), second_set.len());
        let intersection_len = first_set.intersection(&second_set).count();

        if intersection_len == smallest_len {
            count_complete += 1;
        }

        if intersection_len > 0 {
            count_partial += 1;
        }
    }

    println!("Partial: {count_partial}, Complete: {count_complete}");
}
